---
title: WEBGL_compressed_texture_atc
slug: Web/API/WEBGL_compressed_texture_atc
tags:
  - API
  - Reference
  - WebGL
  - WebGL extensions
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>WEBGL_compressed_texture_atc</strong></code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and exposes 3 ATC compressed texture formats. ATC is a proprietary compression algorithm for compressing textures on handheld devices.</p>

<p>Compressed textures reduce the amount of memory needed to store a texture on the GPU, allowing for higher resolution textures or more of the same resolution textures.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability: </strong>ATC compression is typically available on mobile devices with <a href="https://en.wikipedia.org/wiki/Adreno">Adreno GPUs</a>, that are currently only built into <a href="https://en.wikipedia.org/wiki/Qualcomm_Snapdragon">Qualcomm Snapdragon</a> devices.</p>

<p>This extension is available to both, {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} and {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}} contexts.</p>
</div>

<h2 id="Constants">Constants</h2>

<p>The compressed texture formats are exposed by 3 constants and can be used in two functions: {{domxref("WebGLRenderingContext.compressedTexImage2D", "compressedTexImage2D()")}} and {{domxref("WebGLRenderingContext.compressedTexSubImage2D", "compressedTexSubImage2D()")}}.</p>

<dl>
 <dt><code>ext.COMPRESSED_RGB_ATC_WEBGL</code></dt>
 <dd>Compresses RGB textures with no alpha channel.</dd>
 <dt><code>ext.COMPRESSED_RGBA_ATC_EXPLICIT_ALPHA_WEBGL</code></dt>
 <dd>Compresses RGBA textures using explicit alpha encoding (useful when alpha transitions are sharp).</dd>
 <dt><code>ext.COMPRESSED_RGBA_ATC_INTERPOLATED_ALPHA_WEBGL</code></dt>
 <dd>Compresses RGBA textures using interpolated alpha encoding (useful when alpha transitions are gradient).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush:js">var ext = gl.getExtension('WEBGL_compressed_texture_atc');

var texture = gl.createTexture();
gl.bindTexture(gl.TEXTURE_2D, texture);

gl.compressedTexImage2D(gl.TEXTURE_2D, 0, ext.COMPRESSED_RGB_ATC_WEBGL, 512, 512, 0, textureData);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_compressed_texture_atc', "", "WEBGL_compressed_texture_atc")}}</td>
   <td>{{Spec2('WEBGL_compressed_texture_atc')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WEBGL_compressed_texture_atc")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexSubImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getParameter()")}}</li>
</ul>
